-- ИДТИ В РАЗДЕЛ "ИНТЕРФЕЙС"











fn getBBoxPoints obj = (
	local bbPoints = #()

	local bbMax = obj.max
	local bbMin = obj.min

	append bbPoints (Point3 bbMax.x bbMax.y bbMax.z)	-- top-right-front corner
	append bbPoints (Point3 bbMax.x bbMin.y bbMax.z)	-- top-right-back corner
	append bbPoints (Point3 bbMin.x bbMin.y bbMax.z)	-- top-left-back corner
	append bbPoints (Point3 bbMin.x bbMax.y bbMax.z)	-- top-left-front corner
	
	append bbPoints (Point3 bbMax.x bbMax.y bbMin.z)	-- bottom-right-front corner
	append bbPoints (Point3 bbMax.x bbMin.y bbMin.z)	-- bottom-right-back corner
	append bbPoints (Point3 bbMin.x bbMin.y bbMin.z)	-- bottom-left-back corner
	append bbPoints (Point3 bbMin.x bbMax.y bbMin.z)	-- bottom-left-front corner
	
	return bbPoints
)


fn gen_unical_name nm = (
iter = 1
while(true) do (
	if ((getNodeByName(nm + "_" + (iter as string))) == undefined) 
		then (return (nm + "_" + (iter as string)) )
		iter = iter + 1
	)
)

fn select_mat_borders obj max_id = (

	local oldObjSel = getCurrentSelection() -- preserve object selection
	clearSelection()
	max modify mode -- switch to modify mode
	--for obj in selObjs do
	--(
		local newESel = #{} -- where to store edges selection
		local ep = Edit_Poly() -- create new EditPolyMod
		addModifier obj ep -- add modifier to the object
		select obj -- select the object
		subObjectLevel = 4 -- #Face SO level
		local oldFSel = ep.GetSelection #Face -- preserve face selection
		local allFaces = #{1..ep.GetNumFaces()} -- get all faces
		for mID = 0 to max_id while allFaces.numberSet > 0 do
		(
			ep.SetSelection #Face #{} -- clean old selection
			ep.selectByMaterialID = mID -- set material ID to select
			ep.SetOperation #SelectByMaterial -- execute selection
			editPolyMod.ConvertSelectionToBorder ep #Face #Edge -- convert the sel.
			newESel += ep.GetSelection #Edge -- append edge sel. to newESel
			allFaces -= ep.GetSelection #Face -- substract face sel. from allFaces
		)
		ep.SetSelection #Face oldFSel -- restore old face selection
		ep.SetSelection #Edge newESel -- select edges (main goal of this script)
		subObjectLevel = 0
	--)
	select oldObjSel -- restore old object selection
)



fn smooth2id obj add = (
	--print ("smooth2id")
	num_faces = polyop.getNumFaces obj 
	max_id = -1
	 for i in 1 to num_faces do
  		(
  			
			new_id = -1
			
			face_SG = polyop.getFaceSmoothGroup obj i
			for j = 1 to 32 do (
				if bit.get face_SG j do
					(
					new_id = add + j
					exit 
					)
				)
			
			if(new_id < 0) then new_id = add
			--setFaceMatID <mesh> <face_index_integer> <integer>
			if(new_id > max_id) do max_id = new_id
			polyop.setFaceMatID obj i new_id

			


  		)
		
	return max_id
	)




fn getBBoxSize obj = (
	local bbPoints = #()

	local bbMax = obj.max
	local bbMin = obj.min

	sx = bbMax.x - bbMin.x
	sy = bbMax.y - bbMin.y
	sz = bbMax.z - bbMin.z

	
	return [sx, sy, sz]
)






	fn proection old_obj old_relef pb Rb=
	(
		--curViewDir = getViewDirectionRay()
		relef = copy old_relef
		relef.name = old_relef.name + "_temp_relief"
		obj = copy old_obj
		obj.name = old_obj.name + "_temp_obj"
		
	MS_modif1 = meshSmooth()
	MS_modif1.iterations = 0	
	addModifier obj MS_modif1
		fm = 0
		
		convertToMesh relef
		convertToMesh obj
		colv = getNumVerts obj
		
		for i = 1 to colv do (
			vert = getVert obj i
			vert_normal = getNormal obj i
			
			test_ray = ray vert vert_normal
			xxx = intersectRay relef test_ray
			
			if(xxx != undefined) do (
				--print((i as string) + "   ||  vert: "  + (vert as string) + "  normal   "     + (vert_normal as string) + "   -->   " + (xxx as string) + "   -->   " + (xxx.pos as string) ) 
				setVert obj i xxx.pos
				)
				
				
			if mod fm 500 == 0 then  (
				gc light:false delayed:false
				print(fm as string)
				)
			fm = fm + 1	
			)
			
	Morph_modifer = Morpher()
	addModifier old_obj Morph_modifer
	Morph_modifer.Use_Selection = 0
	WM3_MC_SetActive Morph_modifer 1 true
	WM3_MC_SetUseVertexSel Morph_modifer 1 0
	WM3_MC_BuildFromNode Morph_modifer 1 obj
	WM3_MC_SetValue Morph_modifer 1 (100 * 1.0)
	
	delete relef
	delete obj
	)
	
	
	


struct brick_gen1 (
	first_smooth = 30,
	turbosmooth_iter = 3,
	turbosmoothSmooth_iter = 2,
	
	
	fn generate_btick1 arr_obj2 = (
	
	
	arr_obj = #()
	for obj in arr_obj2 do (append arr_obj obj)
	
	
	for obj in arr_obj do (
		print obj.name
		new_obj = copy obj
		
		smooth_mod = smoothModifier()
		smooth_mod.autosmooth  = true
		smooth_mod.threshold = first_smooth
		addModifier new_obj smooth_mod
		
		meshsmoth_mod = meshSmooth()
		meshsmoth_mod.sepBySmGroups  = true 
		meshsmoth_mod.iterations  = turbosmooth_iter
		meshsmoth_mod.isolineDisplay = false
		addModifier new_obj meshsmoth_mod
		
		emesh = MeshSelect()
		addModifier new_obj emesh
		
		
		meshsmoth_mod2 = meshSmooth()
		--meshsmoth_mod2.sepBySmGroups  = true 
		meshsmoth_mod2.iterations  = turbosmoothSmooth_iter
		meshsmoth_mod2.isolineDisplay = false
		addModifier new_obj meshsmoth_mod2
		
		
		tesselate_mod = Tessellate()
		tesselate_mod.tension = 0
		tesselate_mod.faceType  = 1
		tesselate_mod.Type  = 1
		tesselate_mod.iterations  = 0
		addModifier new_obj tesselate_mod
		
		-- borders
		noisemap = noise()
		noisemap.type = 1
		noisemap.size = 0.3	
		noisemap.thresholdHigh = 0.65
		noisemap.thresholdLow = 0.35		
		noisemap.coords.coordType = 1
		noisemap.phase = random 1.0 10000000.0
		
		volumeselect_mod = volumeselect()		
		volumeselect_mod.level = 1
		volumeselect_mod.method  = 0
		volumeselect_mod.volume  = 4
		volumeselect_mod.texture    = noisemap		
		addModifier new_obj volumeselect_mod
		
		
		relax_modifer = Relax() 
		relax_modifer.iterations = turbosmoothSmooth_iter * 30
		relax_modifer.Relax_Value  = 1.0		
		addModifier new_obj relax_modifer




		noisemap2 = noise()
		noisemap2.type = 1
		noisemap2.size = 0.1	
		noisemap2.thresholdHigh = 0.65
		noisemap2.thresholdLow = 0.55		
		noisemap2.coords.coordType = 1
		noisemap.phase = random 1.0 10000000.0
		
		volumeselect_mod2 = volumeselect()		
		volumeselect_mod2.level = 1
		volumeselect_mod2.method  = 0
		volumeselect_mod2.volume  = 4
		volumeselect_mod2.texture    = noisemap2		
		addModifier new_obj volumeselect_mod2
		
		
		relax_modifer2 = Relax() 
		relax_modifer2.iterations = turbosmoothSmooth_iter * 100
		relax_modifer2.Relax_Value  = 1.0		
		addModifier new_obj relax_modifer2
		
		emesh2 = MeshSelect()
		addModifier new_obj emesh2
		
		--errosium
		ernoisemap = noise()
		ernoisemap.type = 1
		ernoisemap.size = 0.78	
		ernoisemap.thresholdHigh = 0.42
		ernoisemap.thresholdLow = 0.2		
		ernoisemap.coords.coordType = 1
		ernoisemap.phase = random 1.0 10000000.0		
		ernoisemap.levels = 10.0
		
		dislace_mod = displace()
		dislace_mod.strength  = 0.065
		dislace_mod.decay   = 0.0
		dislace_mod.lumCenterEnable    = true
		dislace_mod.center     = 1
		dislace_mod.map     = ernoisemap
		dislace_mod.useMap      = true
		addModifier new_obj dislace_mod
		
		emesh2 = MeshSelect()
		addModifier new_obj emesh2
		
		noise_mod = Noisemodifier ()
		noise_mod.seed = random 1.0 10000000.0
		noise_mod.scale = 1.0
		noise_mod.fractal  = true
		noise_mod.roughness  = 0.0
		noise_mod.iterations   = 10
		noise_mod.strength    = [0.05, 0.05, 0.05]
		addModifier new_obj noise_mod
		
		--optimize_object = copy new_obj
		--opt_mod = ProOptimizer()
		--select new_obj
		--addModifier new_obj opt_mod ui:on
		--opt_mod.VertexCount  = 5000
		--opt_mod.OptimizationMode = 1 
		--opt_mod.Calculate = on
		--opt_mod.VertexCount  = 5000
		
		ConvertTo new_obj Editable_Poly
		numFaces = getNumFaces new_obj
		num_polys = 5000
		percent = (num_polys * 100.0) / numFaces
		
		select new_obj
		optMod = ProOptimizer()
		addModifier new_obj optMod
		
		optMod.Calculate = true
		optMod.OptimizationMode = 1
		optMod.CompactFaces  = true
		optMod.LockMat = False
		optMod.KeepUV  = False
		optMod.LockUV  = False
		optMod.KeepVC  = False
		
		
		redrawviews()
		
		
		
		optMod.Calculate = true
		--optMod.VertexCount  = 5000
		
		
		
		
		optMod.VertexPercent   = percent
		convertToMesh new_obj
		
		)
	)
	
	)
	


function getNeighborVertex2 geom vertex =
(
    local verts = polyop.getVertsUsingEdge geom (polyop.getEdgesUsingVert geom vertex)
    verts[vertex] = false
    return verts
)



struct brick_gen2 (

	test_inform = true,
	esz = [0.0,0.0,0.0],
	test_return = false,	
	-- first meshSmooth forma
	element_form_subdivide = 1,
	
	-- second mesh smooth, borders
	element_smooth_subdivide = 1,
	element_smooth_hard_bordies = false,
	element_smooth_threshold = 0.85,
	
	element_big_displace_cellularmap_size = 1.50,
	element_big_displace_strength = 0.05,
	element_big_displace_center = 1.0,	
	
	element_little_displace_cellularmap_size = 0.50,
	element_little_displace_strength = 0.01,
	element_little_displace_center = 1.0,		
	
	
	erosion_form_subdivide = 1,
	
	erosion_smooth_subdivide = 1,	
	
	erosion_relax = 12.0,
	
	erosion_push = 0.0,    --0.0425,
	
	erosion_big_displace_cellularmap_size = 1.50,
	erosion_big_displace_strength = 0.20,
	erosion_big_displace_center = 1.0,	
	
	erosion_little_displace_cellularmap_size = 0.50,
	erosion_little_displace_strength = 0.05,
	erosion_little_displace_center = 1.0,	
	
	welder_threshold = 0.005,


	
	fn patern_1 = (
		),
	
	
	
	
	
	
	
	
	fn generateHP obj = (
	
	ts0 = timeStamp()
	

	print("		generateHP:	submesh " + obj.name)
	
	isz = 0
	if(amin (#(esz.x, esz.y, esz.z)) <= 0.0) then (
		isz = getBBoxSize obj
		print("		generateHP:	CALCULATE SIZE")
		)
	else (
		isz = esz
		)
		
		
	print("		generateHP:	isz " + (isz as string))
	gsz = amin (#(isz.x, isz.y, isz.z))
	print("		generateHP:	gsz " +( gsz as string))
	
	new_obj = copy obj
	ConvertTo new_obj Editable_Poly
	new_obj.name = "new_obj"
	-- convert smooth groups to material id
	max_id = smooth2id new_obj 1
	
	
	-- smooth object
	meshsmoth_mod = meshSmooth()
	meshsmoth_mod.sepByMats   = true 
	meshsmoth_mod.iterations  = element_form_subdivide
	meshsmoth_mod.isolineDisplay = false
	addModifier new_obj meshsmoth_mod	
	

	-- convert to mesh, reset ctease
	emesh = MeshSelect()
	addModifier new_obj emesh	
	
	-- smooth object border
	meshsmoth_mod3 = meshSmooth()
	meshsmoth_mod3.sepByMats  = element_smooth_hard_bordies 
	meshsmoth_mod3.iterations  = element_smooth_subdivide 
	meshsmoth_mod3.smoothness  = element_smooth_threshold
	meshsmoth_mod3.isolineDisplay = false
	addModifier new_obj meshsmoth_mod3	


	ts1 = timeStamp()
	if(test_inform) do print ("		generateHP:	T1 processing took " + ((ts1 - ts0) as string) )
	
	/*
	chamfermod = Chamfer()
	chamfermod.chamfertype = 0
	chamfermod.amount = 0.4
	chamfermod.tension  = 0.5
	chamfermod.selectionoption  = 5
	chamfermod.materialoption       = 1
	chamfermod.useminangle            = false
	addModifier new_obj chamfermod	
	--return new_obj
	ConvertTo new_obj Editable_Poly*/
	
	cut_obj = copy obj
	cut_obj.name = "cut_obj"
	ConvertTo cut_obj Editable_Poly
	
	-- convert smooth groups to material id
	max_id = smooth2id cut_obj ( max_id + 10)

		
	--smooth cut object
	meshsmoth_mod2 = meshSmooth()
	meshsmoth_mod2.sepByMats  = true 
	meshsmoth_mod2.iterations  = erosion_form_subdivide 
	meshsmoth_mod2.isolineDisplay = false
	addModifier cut_obj meshsmoth_mod2		

	-- reset cut object crease 
	emesh = MeshSelect()
	addModifier cut_obj emesh	
	
	-- smooth cut object borders
	meshsmoth_mod3 = meshSmooth()
	meshsmoth_mod3.sepByMats  = false 
	meshsmoth_mod3.iterations  = erosion_smooth_subdivide 
	meshsmoth_mod3.isolineDisplay = false
	addModifier cut_obj meshsmoth_mod3	
	
	
	-- reset cut object crease
	emesh = MeshSelect()
	addModifier cut_obj emesh	
		
		
	-- relax cut object	
	relax_modifer = Relax() 
	relax_modifer.iterations = erosion_relax
	relax_modifer.Relax_Value  = 1.0		
	addModifier cut_obj relax_modifer		
		
	-- push cut object	
	push_mod = push()
	push_mod.Push_Value = erosion_push * gsz
	addModifier cut_obj push_mod

	ts2 = timeStamp()
	if(test_inform) do print ("		generateHP:	T2 processing took " + ((ts2 - ts1) as string) )

	/*
	-- noise cut object. 
		-- DISPLACE BEST!!!
		
		
	noise_mod = Noisemodifier ()
	noise_mod.seed = random 1.0 10000000.0
	noise_mod.scale = cut_noise_size
	noise_mod.fractal  = true
	noise_mod.roughness  = 0.0
	noise_mod.iterations   = 10
	noise_mod.strength    = [cut_noise_size_strenght * gsz, cut_noise_size_strenght * gsz, cut_noise_size_strenght * gsz]
	--addModifier cut_obj noise_mod	
	*/


	-- create map for displace 
	Cellularmap = Cellular ()
	Cellularmap.size = erosion_big_displace_cellularmap_size * gsz
	Cellularmap.fractal  = true
	Cellularmap.coords.coordType = 1
	Cellularmap.coords.offset = [(random 0.0 1000000.0 ) , (random 0.0 1000000.0 ) , (random 0.0 1000000.0 )]
	Cellularmap.coords.angle  = [(random 0.0 360.0 ) , (random 0.0 360.0 ) , (random 0.0 360.0 )]



	--displace cut object
	dislace_mod = displace()
	dislace_mod.strength  = -1  * gsz * erosion_big_displace_strength
	dislace_mod.decay   = 0.0
	dislace_mod.lumCenterEnable    = true
	dislace_mod.center     = erosion_big_displace_center
	dislace_mod.map     = Cellularmap
	dislace_mod.useMap      = true
	addModifier cut_obj dislace_mod
	
	
	
	-- create map for displace 
	Cellularmap2 = Cellular ()
	Cellularmap2.size = erosion_little_displace_cellularmap_size * gsz
	Cellularmap2.fractal  = true
	Cellularmap2.coords.coordType = 1
	Cellularmap2.coords.offset = [(random 0.0 1000000.0 ) , (random 0.0 1000000.0 ) , (random 0.0 1000000.0 )]
	Cellularmap2.coords.angle  = [(random 0.0 360.0 ) , (random 0.0 360.0 ) , (random 0.0 360.0 )]



	--displace cut object
	dislace_mod2 = displace()
	dislace_mod2.strength  = -1  * gsz * erosion_little_displace_strength
	dislace_mod2.decay   = 0.0
	dislace_mod2.lumCenterEnable    = true
	dislace_mod2.center     = erosion_little_displace_center
	dislace_mod2.map     = Cellularmap2
	dislace_mod2.useMap      = true
	addModifier cut_obj dislace_mod2	
	
	
	
	






	-- create map for displace 
	Cellularmap3 = Cellular ()
	Cellularmap3.size = element_big_displace_cellularmap_size * gsz
	Cellularmap3.fractal  = true
	Cellularmap3.coords.coordType = 1
	Cellularmap3.coords.offset = [(random 0.0 1000000.0 ) , (random 0.0 1000000.0 ) , (random 0.0 1000000.0 )]
	Cellularmap3.coords.angle  = [(random 0.0 360.0 ) , (random 0.0 360.0 ) , (random 0.0 360.0 )]



	--displace cut object
	dislace_mod3 = displace()
	dislace_mod3.strength  = -1  * gsz * element_big_displace_strength
	dislace_mod3.decay   = 0.0
	dislace_mod3.lumCenterEnable    = true
	dislace_mod3.center     = element_big_displace_center
	dislace_mod3.map     = Cellularmap3
	dislace_mod3.useMap      = true
	addModifier new_obj dislace_mod3
	
	
	
	-- create map for displace 
	Cellularmap4 = Cellular ()
	Cellularmap4.size = element_little_displace_cellularmap_size * gsz
	Cellularmap4.fractal  = true
	Cellularmap4.coords.coordType = 1
	Cellularmap4.coords.offset = [(random 0.0 1000000.0 ) , (random 0.0 1000000.0 ) , (random 0.0 1000000.0 )]
	Cellularmap4.coords.angle  = [(random 0.0 360.0 ) , (random 0.0 360.0 ) , (random 0.0 360.0 )]



	--displace cut object
	dislace_mod4 = displace()
	dislace_mod4.strength  = -1  * gsz * element_little_displace_strength
	dislace_mod4.decay   = 0.0
	dislace_mod4.lumCenterEnable    = true
	dislace_mod4.center     = element_little_displace_center
	dislace_mod4.map     = Cellularmap4
	dislace_mod4.useMap      = true
	addModifier new_obj dislace_mod4	










	ts3 = timeStamp()
	if(test_inform) do print ("		generateHP:	T3 processing took " + ((ts3 - ts2) as string) )







			
	-- INACHE BOOLDEAN SBROSIT MATERIAL ID. 		
	mat1 = multiSubMaterial()
	mat1.numsubs  = 200
	new_obj.material = mat1
	cut_obj.material = mat1
	


	
	if (test_return) do ( 
		ts1008 = timeStamp()
		print ("		generateHP:	FINAL 3 processing took " + ((ts1008 - ts0) as string) )
		return new_obj
		)
	ConvertTo cut_obj Editable_Poly
	
	
	-- reset materialID cut object
	--num_faces = polyop.getNumFaces cut_obj
	--for fc in 1 to num_faces do
  		--(
			
		--	polyop.setFaceMatID cut_obj fc 100
  		--)
	
	
	
	--PROBOOLEAN
		--max modify mode
	proboolean.setoperandA new_obj
	proboolean.SetBoolOp new_obj 1 -- set subtract boolean op
		--proboolean.SetImprint new_obj true
	proboolean.SetPlanarEdgeRemoval new_obj 2
	proboolean.setDisplayResult new_obj true
	proboolean.setoperandB new_obj cut_obj 4 2
		--ConvertToMesh cut_obj
	
	
	--return new_obj
	
	
	
	
	ConvertToPoly new_obj	
	
	
	-- OTCHISTKA POSLE BOOLEAN
		-- RABOTAET PLOHO
	
	ts4 = timeStamp()
	if(test_inform) do print ("		generateHP:	T4 processing took " + ((ts4 - ts3) as string) )	
	
	--new_obj.EditablePoly.SetSelection #Edge ((polyOp.getOpenEdges $) as bitarray)
	open_edges = ((polyOp.getOpenEdges new_obj) as bitarray)
	open_vertex = polyop.getVertsUsingEdge new_obj open_edges
	polyop.setVertSelection new_obj open_vertex

	
	-- weld vertex
	if(welder_threshold > 0) do (
		welder_mod = Vertex_Weld()
		welder_mod.threshold   = welder_threshold * gsz
		addModifier new_obj welder_mod
		)
	

	ConvertToPoly new_obj	
	
	
	ts5 = timeStamp()
	if(test_inform) do print ("		generateHP:	T5 processing took " + ((ts5 - ts4) as string) )	
	
	-- Remove 2-edges vertex
	rem_ver = #()	
	sverts = new_obj.GetNumVertices() --(polyop.getVertSelection new_obj) as array	
	for vert = 1 to sverts  do (	
		tmp_vert_ar1 = (polyop.getEdgesUsingVert new_obj (int(vert))) as array
		if(tmp_vert_ar1.count == 2) do append rem_ver vert 		
		)
	polyop.setVertSelection new_obj rem_ver	
	new_obj.EditablePoly.Remove selLevel:#Vertex
	print ("		generateHP:	remove " + (rem_ver.count as string )+ " 2-edge vertices")
		
		
	--TEST	
	--polyOp.detachFaces	new_obj #{1,2, 17, 128}  delete:false asNode:false
	--return  new_obj	

	ts6 = timeStamp()
	if(test_inform) do print ("		generateHP:	T6 processing took " + ((ts6 - ts5) as string) )

		
	-- remove unused polygons
	max_obj = 0

	while new_obj.getNumFaces() != 0 do (
			polyop.setFaceSelection new_obj #{1}
			new_obj.selectElement()
			faces_element = polyop.getFaceSelection new_obj
			newName = gen_unical_name ("tmp_element")
			
			
			/*
						polyop.setFaceSelection new_obj #{1}
			new_obj.selectElement()
			faces_element = polyop.getFaceSelection new_obj
			newName = gen_unical_name ("tmp_element")
			
			--detach_element = mesh()
			--ConvertTo detach_element Editable_Poly
			
			
			--polyop.detachFaces new_obj faces_element asNode:true node:detach_element
			--detach_element = getNodeByName newName
			--detach_element.name = newName
			--ConvertTo detach_element Editable_Poly
			
			
			polyop.detachFaces new_obj faces_element asNode:true name:newName
			detach_element = getNodeByName newName
			ConvertTo detach_element Editable_Poly
			*/
			
			
			polyop.detachFaces new_obj faces_element asNode:true name:newName
			detach_element = getNodeByName newName
			ConvertTo detach_element Editable_Poly
			
			print("		generateHP:	detach " + (detach_element.getNumFaces() as string))
			
			if(max_obj == 0) then (
				max_obj = detach_element
				print ("		generateHP:	set max_obj " + (max_obj.getNumFaces() as string) )
				)
			else
				(
				if( detach_element.getNumFaces() > max_obj.getNumFaces()) then (
					print("		generateHP:	delete " + (max_obj.getNumFaces() as string))
					delete max_obj
					max_obj = detach_element
					)
				else (
					print("		generateHP:	delete " + (detach_element.getNumFaces() as string))
					delete detach_element
					)
				)
				
			)
	polyop.attach new_obj max_obj
	
	
	
	test_value = ((polyOp.getOpenEdges new_obj) as array)
	
	ts7 = timeStamp()
	if(test_inform) do print ("		generateHP:	T7 processing took " + ((ts7 - ts6) as string) )	
	
	if(test_value.count > 0) do 
		(
		
		print ("		generateHP:	FINAL 2 processing took " + ((ts7 - ts0) as string) )
		print ("	generateHP:	OPEN EDGES!!! RESET!")		
		delete new_obj
		return 0
		)
	
	
	-- cap holes
	cap_mod = cap_holes()
	--cap_mod.Make_All_New_Edges_Visible  = false
	addModifier new_obj cap_mod	
		
		
	ts1009 = timeStamp()
	print ("		generateHP:	FINAL 1 processing took " + ((ts1009 - ts0) as string) )	
	return  new_obj		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
	

	
	meshsmoth_mod4 = meshSmooth()
	meshsmoth_mod4.sepByMats  = true 
	meshsmoth_mod4.iterations  = 1 
	meshsmoth_mod4.smoothness  = 0.998
	meshsmoth_mod4.isolineDisplay = false
	addModifier new_obj meshsmoth_mod4	
	
	ts8 = timeStamp()
	print ("		FINAL 1 processing took " + ((ts8 - ts0) as string) )


		
	return new_obj
	ConvertTo new_obj Editable_Poly
	
	subdivide_mod = subdivide()
	subdivide_mod.size  = 100.0
	
	addModifier new_obj subdivide_mod	
	
	
	ConvertTo new_obj Editable_Poly
	
	select_mat_borders new_obj 200
	ConvertTo new_obj Editable_Poly


	ts8 = timeStamp()
	if(test_inform) do print ("T8 processing took " + ((ts8 - ts7) as string) )	
	
	
	bedges = polyop.getEdgeSelection new_obj
	bverts = polyop.getVertsUsingEdge new_obj bedges
	bfaces = polyop.getFacesUsingVert new_obj bverts
	--polyop.setFaceSelection  new_obj bfaces
	polyop.meshSmoothByFace new_obj bfaces
	polyop.retriangulate new_obj #All
	
	subdivide_mod2 = subdivide()
	subdivide_mod2.size  = 100.0
	--addModifier new_obj subdivide_mod2


	relax_modifer = Relax() 
	relax_modifer.iterations = 1
	relax_modifer.Relax_Value  = 1.0		
	--addModifier new_obj relax_modifer		



	
	
	
		return new_obj
		gc light:false delayed:false
		
	)
	)

	
arr_obj = #()
for obj in selection do (append arr_obj obj)	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
fn hp_border_Tesselate HP_Element = (


	subdivide_mod = subdivide()
	subdivide_mod.showAllTriangles  = true
	subdivide_mod.size   = 1000000
	addModifier HP_Element subdivide_mod
	
	TS_modifer = Tessellate()
	TS_modifer.tension = 0 * 100
	TS_modifer.faceType  = 0
	TS_modifer.type = 0
	TS_modifer.iterations = 0			
	addModifier HP_Element TS_modifer

	relax_modifer = Relax() 
	relax_modifer.iterations = 1
	relax_modifer.Relax_Value  = 1.0		
	relax_modifer.Keep_Boundary_Pts_Fixed   = 0
	addModifier HP_Element relax_modifer

	optimize_mod = optimize()
	optimize_mod.MaxEdgeLength1  = 0.5
	optimize_mod.autoedge   = false
	addModifier HP_Element optimize_mod


return HP_Element
)	
	
	
	
fn hp_border_TesselateProOpt HP_Element opt_percent = (


	subdivide_mod = subdivide()
	subdivide_mod.showAllTriangles  = true
	subdivide_mod.size   = 1000000
	addModifier HP_Element subdivide_mod
	
	TS_modifer = Tessellate()
	TS_modifer.tension = 0 * 100
	TS_modifer.faceType  = 0
	TS_modifer.type = 0
	TS_modifer.iterations = 0			
	addModifier HP_Element TS_modifer

	relax_modifer = Relax() 
	relax_modifer.iterations = 1
	relax_modifer.Relax_Value  = 1.0		
	relax_modifer.Keep_Boundary_Pts_Fixed   = 0
	addModifier HP_Element relax_modifer






	ConvertTo HP_Element Editable_Poly
	numFaces = getNumFaces HP_Element
	num_polys = 5000
	percent = opt_percent --(num_polys * 100.0) / numFaces
	
	if(opt_percent < 100) do (
		select HP_Element
		optMod = ProOptimizer()
		addModifier HP_Element optMod
		
		optMod.Calculate = true
		optMod.OptimizationMode = 1
		optMod.CompactFaces  = true
		optMod.LockMat = False
		optMod.KeepUV  = False
		optMod.LockUV  = False
		optMod.KeepVC  = False
		
		
		redrawviews()
		
		
		
		optMod.Calculate = true
		--optMod.VertexCount  = 5000
		
		
		
		
		optMod.VertexPercent   = percent
	)
	
	
	convertToMesh HP_Element
		
		
		


return HP_Element
)		
	
	
	
	
	
fn hp_border_MeshSmooth HP_Element = (	

	meshsmoth_mod = meshSmooth()
	meshsmoth_mod.sepBySmGroups  = false
	meshsmoth_mod.iterations  = 1
	meshsmoth_mod.isolineDisplay = false
	meshsmoth_mod.smoothness = 0.9999
	addModifier HP_Element meshsmoth_mod
	
	subdivide_mod = subdivide()
	subdivide_mod.showAllTriangles  = true
	subdivide_mod.size   = 1000000
	addModifier HP_Element subdivide_mod
	
	
	relax_modifer = Relax() 
	relax_modifer.iterations = 1
	relax_modifer.Relax_Value  = 1.0		
	relax_modifer.Keep_Boundary_Pts_Fixed   = 0
	--save outer corners тоже надо отключить, но в описании его почему-то нет
	addModifier HP_Element relax_modifer
	
	optimize_mod = optimize()
	optimize_mod.MaxEdgeLength1  = 0.5
	optimize_mod.autoedge   = false
	addModifier HP_Element optimize_mod	
	
return HP_Element
)		
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
		/*
		ИНТЕРФЕЙС 
		Просто выделить нужные объекты и запустить скрипт


		##################################################################

		ПРЕДУПРЕЖДЕНИЯ:

		1 МОДЕЛЬ РАЗБИВАЕТСЯ НА ОСНОВЕ ГРУПП СГЛАЖИВАНИЯ
		2 НЕ ПЫТАТЬСЯ РАБОТАТЬ С НЕЗАМКНУТЫМИ МОДЕЛЯМИ (borders быть НЕ ДОЛЖНО).
		3 Лучше не злоупотреблять многоугольниками. (5 - нормально, но больше - лучше не надо)

		###################################################################################

		join_mesh - сколлапсить стек и объединить сабмеши
		g_test_return - вернуть промежуточные значения

		Алгоритм такой:

		Отделяем небольшой кусок стены.
		Ставим

		join_mesh = false:
		g_test_return = true

		отлаживаемся на нем.

		возвращаем:
		join_mesh = false
		g_test_return = false

		Смотрим, если все нормально:

		join_mesh = true
		g_test_return = false

		И запускаем проход по всему объекту


		seed (timeStamp ()) - для рандомной рандомизации
		seed 1 для предустановленной рандомизации

		*/	




logfile="D:\HPbrick_generator.log" 		-- если путь существует, пишем туда лог. 
										-- Если не существует - не пишем
										
if ( (getfiles logfile).count != 0 ) then (	openLog logfile mode:"a" outputOnly:true )


seed (timeStamp ())
join_mesh = true 						-- Объединять объекты или нет	
g_test_return = false


optimize_percent = 20 					-- Процент оптитзации





										-- brick_gen2 - фактически обертка для функции generateHP
										-- нужен просто для предоставления интерфейса



										-- МЕНЯЕМ ПРЕДУСТАНОВЛЕННЫЕ ПАРАМЕТРЫ, подбираем вручную.
										-- Подробнее см. в самой структуре
bg = brick_gen2() 

bg.esz = [1.0, 1.0, 1.0] 		 		--устанавливаем размер элемента (point3).
										--Нужен для подстройки относительеых параметров. 
										--Еще можно подставитьфиксированное или рандомное значение
										--Если хоть одно значение sz.XXX <= 0.0, функция сама пересчитает его по новой
									





/*
bg.element_form_subdivide = 2
bg.erosion_form_subdivide = 0
bg.erosion_smooth_subdivide = 3			
bg.erosion_relax = 3
bg.erosion_big_displace_strength = 0.475
bg.erosion_push =  -0.15 --0.02
bg.erosion_big_displace_cellularmap_size = 3.6
*/





bg.element_form_subdivide = 2
bg.erosion_form_subdivide = 1
bg.erosion_smooth_subdivide = 2			
bg.erosion_relax = 7
bg.erosion_push =  0 --0.02
bg.erosion_big_displace_cellularmap_size = 3.6
bg.erosion_big_displace_strength = 0

bg.erosion_little_displace_cellularmap_size = 1.7
bg.erosion_little_displace_strength = 0.338








									
									
									
									
									
ts2001 = timeStamp()
ts2002 = timeStamp()
										
									


	
	
with undo off ( -- теоретически должно ускорить	
	
for obj in 	arr_obj do (

	print(" ")
	print(" ")
	print("############")
	print("object " + obj.name + "		time: " + localTime)
	print(" ")
	
	new_obj = copy obj
	new_obj.name = obj.name + "LPcopy"
	ConvertTo new_obj Editable_Poly
	
	
	HP_obj = 0
	if(join_mesh) do (
		HP_obj = copy obj
		HP_obj.name = obj.name + "_HPerosion"
		ConvertTo HP_obj Editable_Poly
		
		polyop.deleteVerts HP_obj #All
		)
	--ConvertTo HP_obj Editable_Mesh	
	--ConvertTo HP_obj Editable_Poly	
	
	
	iter = 1
	while new_obj.getNumFaces() != 0 do (
			ts2001 = timeStamp()

			
			
			polyop.setFaceSelection new_obj #{1}
			new_obj.selectElement()
			faces_element = polyop.getFaceSelection new_obj
			newName = gen_unical_name("tmp_element")
			
			polyop.detachFaces new_obj faces_element asNode:true name:newName
			detach_element = getNodeByName newName
			ConvertTo detach_element Editable_Poly
			print ("	")
			print ("	" + obj.name + "_" + (iter as string) + "_HPerosion"    + "		time: " + localTime)
			
			

			
			bg.test_return = g_test_return -- если ИСТИНА, не доводит алгоритм до конца. Сохраняет обрезающий  объект. удобно для подбора параметров  
						-- перед рабочим проходом установить в ЛОЖЬ
			
			ts3002 = timeStamp()
			print ("	TE1 processing took " + ((ts3002 - ts2001) as string) )
			
			HP_Element = 0 
			test_iter = 0
			while (HP_Element == 0) do ( -- Циклически подсовываем одну и ту же заготовку, пока она не порежется нормально 
				HP_Element = bg.generateHP detach_element
				
											--Сброс при зацикливании
				if(test_iter > 50) do throw "More than 50 unsuccessful generation attempts. The script was aborted. Check geometry and generation parameters"
				
				test_iter = test_iter + 1
				
				)
			HP_Element.name = ("	" + obj.name + "_" + (iter as string) + "_HPerosion")

			ts3003 = timeStamp()
			print ("	TE2 processing took " + ((ts3003 - ts3002) as string) )
			
			-- обработка краев.
			--Пока оптимальгый вариант, который нашел - сабдив (режем на треугольники), релакс (сглаживаем грани) и оптимайз
			--Надо что-то придумать про оптимайз. Работает - не фонтан.
			-- смотреть реализацию функций hp_border_*
			
			if (join_mesh) then (
				
				
				ts3004 = timeStamp()

				
				if(g_test_return == false) do 	hp_border_TesselateProOpt HP_Element optimize_percent
				ts3005 = timeStamp()
				
				
				print ("	TE3 processing took " + ((ts3005 - ts3004) as string) )

				
				polyop.attach HP_obj HP_Element
				--meshop.attach HP_obj HP_Element
				--delete HP_Element
				
				
				ts3006 = timeStamp()
				print ("	TE4 processing took " + ((ts3006 - ts3005) as string) )	
				
				)
			else (
				ts3004 = timeStamp()
				if(g_test_return == false) do 	hp_border_TesselateProOpt HP_Element optimize_percent	
				ts3005 = timeStamp()	
				print ("	TE3 processing took " + ((ts3005 - ts3004) as string) )
				
				)
				
			delete detach_element
			iter = iter + 1
			
			redrawviews()
			
			gc light:false delayed:false
			
			ts2002 = timeStamp()
			print ("	SUBELEMENT GENERATE processing took " + ((ts2002 - ts2001) as string) )
			print ("")
			)
			
			

	
	
	
	delete new_obj
)

)
